import * as next_image from 'next/image';
import * as next_dist_shared_lib_get_img_props from 'next/dist/shared/lib/get-img-props';
import React from 'react';

declare const Picture: React.ForwardRefExoticComponent<Omit<React.DetailedHTMLProps<React.ImgHTMLAttributes<HTMLImageElement>, HTMLImageElement>, "src" | "srcSet" | "ref" | "alt" | "width" | "height" | "loading"> & {
    src: string | next_dist_shared_lib_get_img_props.StaticImport;
    alt: string;
    width?: number | `${number}`;
    height?: number | `${number}`;
    fill?: boolean;
    loader?: next_image.ImageLoader;
    quality?: number | `${number}`;
    priority?: boolean;
    loading?: "eager" | "lazy" | undefined;
    placeholder?: next_dist_shared_lib_get_img_props.PlaceholderValue;
    blurDataURL?: string;
    unoptimized?: boolean;
    onLoadingComplete?: next_dist_shared_lib_get_img_props.OnLoadingComplete;
    layout?: string;
    objectFit?: string;
    objectPosition?: string;
    lazyBoundary?: string;
    lazyRoot?: string;
} & React.RefAttributes<HTMLImageElement>>;

export { Picture as default };
